################################################################################
##### Importing normalized expression data into R
################################################################################
library(WGCNA)
library(tidyverse)
allowWGCNAThreads()

targets <- read.csv("study_design.csv", header = T) %>%
    filter(!grepl("constant_light",sample_name))
datExpr.df <- read_tsv("Analyses/EDA/tables/count_voom_transformed_qsmooth.tsv")
sampleLabels <- targets$sample_name

colnames(datExpr.df) <- c("GeneID", sampleLabels)
datExpr <- t(datExpr.df[, -1])
colnames(datExpr) <- datExpr.df$GeneID

gsg <- goodSamplesGenes(datExpr, verbose = 3)
gsg$allOK
if (!gsg$allOK)
{
    # Optionally, print the gene and sample names that were removed:
    if (sum(!gsg$goodGenes)>0) 
        printFlush(paste("Removing genes:", paste(names(datExpr)[!gsg$goodGenes], collapse = ", ")));
    if (sum(!gsg$goodSamples)>0) 
        printFlush(paste("Removing samples:", paste(rownames(datExpr)[!gsg$goodSamples], collapse = ", ")));
    # Remove the offending genes and samples from the data:
    datExpr <- datExpr[gsg$goodSamples, gsg$goodGenes]
}

traitData <- read.csv("study_design.csv", header = T)
traitData$replicate <- as.factor(traitData$replicate)


allTraits <- traitData[, c(2,6, 7, 8, 9:34)]
colnames(allTraits) <- c("sample_name", "replicate", "time", "temperature", "light_intensity", colnames(allTraits)[6:30])

tableSamples <- rownames(datExpr)
traitRows <- match(tableSamples, allTraits$sample_name)
datTraits <- allTraits[traitRows, -1]
rownames(datTraits) <- allTraits[traitRows, 1]
collectGarbage()
################################################################################
##### Check for outliers
################################################################################
library(flashClust)
# sample network based on squared Euclidean distance
# note that we transpose the data
A=adjacency(t(datExpr),type="distance")
# this calculates the whole network connectivity
k=as.numeric(apply(A,2,sum))-1
# standardized connectivity
Z.k=scale(k)

# Designate samples as outlying
# if their Z.k value is below the threshold
thresholdZ.k=-5 # often -2.5 previously 5

# the color vector indicates outlyingness (red)
outlierColor=ifelse(Z.k<thresholdZ.k,"red","black")

# calculate the cluster tree using flahsClust or hclust
sampleTree = flashClust(as.dist(1-A), method = "complete")
# Convert traits to a color representation:
# where red indicates high values
traitColors=data.frame(numbers2colors(sapply(datTraits, as.numeric),signed=FALSE))
dimnames(traitColors)[[2]]=paste(names(datTraits),sep="")
datColors=data.frame(outlier=outlierColor,traitColors)
# Plot the sample dendrogram and the colors underneath.
plotDendroAndColors(sampleTree,groupLabels=names(datColors),
                    colors=datColors,
                    cex.dendroLabels = 0.8,
                    cex.colorLabels = 0.5,
                    cex.rowText = 0.6,
                    guideAll = FALSE,
                    addGuide = FALSE,
                    main="M. endlicherianum Sample dendrogram and trait heatmap")


# Step 1: Call the pdf command to start the plot
pdf(file = "Analyses/WGCNA/plots/check_for_outliers.pdf",   # The directory you want to save the file in
    width = 20, # The width of the plot in inches
    height = 20) # The height of the plot in inches
# Step 2: Create the plot with R code
plotDendroAndColors(sampleTree,groupLabels=names(datColors),
                    colors=datColors,
                    cex.dendroLabels = 0.8,
                    cex.colorLabels = 0.5,
                    cex.rowText = 0.6,
                    guideAll = FALSE,
                    addGuide = FALSE,
                    main="M. endlicherianum Sample dendrogram and trait heatmap")
# Step 3: Run dev.off() to create the file!
dev.off()

# Remove outlying samples from expression and trait data
remove.samples= Z.k<thresholdZ.k | is.na(Z.k)
datExpr=datExpr[!remove.samples,]
datTraits=datTraits[!remove.samples,]
# Recompute the sample network among the remaining samples
A=adjacency(t(datExpr),type="distance")
# Let's recompute the Z.k values of outlyingness
k=as.numeric(apply(A,2,sum))-1
Z.k=scale(k)
################################################################################
##### Choose a set of soft-thresholding powers
################################################################################
# Choose a set of soft-thresholding powers
powers <- c(c(1:50))
# Call the network topology analysis function
sft <- pickSoftThreshold(data = datExpr, powerVector = powers, verbose = 5, corFnc = "bicor",
                         blockSize = 20000, networkType="signed", moreNetworkConcepts = TRUE)

sft_df <- as.data.frame(sft$fitIndices)
write_tsv(file = "Analyses/WGCNA/tables/soft_threshold.tsv", x = sft_df)
# Plot the results:
sizeGrWindow(9, 5)
par(mfrow = c(1,2))
cex1 = 0.9
# Scale-free topology fit index as a function of the soft-thresholding power
{plot(sft$fitIndices[,1], -sign(sft$fitIndices[,3])*sft$fitIndices[,2],
      xlab="Soft Threshold (power)",ylab="Scale Free Topology Model Fit,signed R^2",type="n",
      main = paste("Scale independence"))
    text(sft$fitIndices[,1], -sign(sft$fitIndices[,3])*sft$fitIndices[,2],
         labels=powers,cex=cex1,col="red")
    # this line corresponds to using an R^2 cut-off of h
    abline(h=0.80,col="red")}
# Mean connectivity as a function of the soft-thresholding power
{plot(sft$fitIndices[,1], sft$fitIndices[,5],
      xlab="Soft Threshold (power)",ylab="Mean Connectivity", type="n",
      main = paste("Mean connectivity"))
    text(sft$fitIndices[,1], sft$fitIndices[,5], labels=powers, cex=cex1,col="red")}

# Step 1: Call the pdf command to start the plot
pdf(file = "Analyses/WGCNA/plots/scale_free_soft_threshold.pdf",   # The directory you want to save the file in
    width = 20, # The width of the plot in inches
    height = 20) # The height of the plot in inches
# Step 2: Create the plot with R code

# Scale-free topology fit index as a function of the soft-thresholding power
{plot(sft$fitIndices[,1], -sign(sft$fitIndices[,3])*sft$fitIndices[,2],
      xlab="Soft Threshold (power)",ylab="Scale Free Topology Model Fit,signed R^2",type="n",
      main = paste("Scale independence"))
    text(sft$fitIndices[,1], -sign(sft$fitIndices[,3])*sft$fitIndices[,2],
         labels=powers,cex=cex1,col="red")
    # this line corresponds to using an R^2 cut-off of h
    abline(h=0.80,col="red")}

# Step 3: Run dev.off() to create the file!
dev.off()

# Step 1: Call the pdf command to start the plot
pdf(file = "Analyses/WGCNA/plots/soft_threshold_power_mean_connectivity.pdf",   # The directory you want to save the file in
    width = 20, # The width of the plot in inches
    height = 20) # The height of the plot in inches
# Step 2: Create the plot with R code

# Mean connectivity as a function of the soft-thresholding power
{plot(sft$fitIndices[,1], sft$fitIndices[,5],
      xlab="Soft Threshold (power)",ylab="Mean Connectivity", type="n",
      main = paste("Mean connectivity"))
    text(sft$fitIndices[,1], sft$fitIndices[,5], labels=powers, cex=cex1,col="red")}

# Step 3: Run dev.off() to create the file!
dev.off()

softPower <- 20
################################################################################
##### Automatic module detection via dynamic tree cutting
################################################################################
mergingThresh = 0.20 # Find this number by manual investigation
net = blockwiseModules(datExpr,
                       corType="bicor",
                       maxBlockSize=60000,
                       networkType="signed",
                       TOMType="signed", # "signed Nowick" or "signed" ?
                       power=softPower,
                       minModuleSize=30,
                       maxPOutliers=0.05,
                       mergeCutHeight=mergingThresh,
                       numericLabels=TRUE,
                       saveTOMs=FALSE,
                       pamRespectsDendro=FALSE,
                       suppressNegativeTOM = FALSE
                       #saveTOMFileBase="TOM"
                       )
moduleLabelsAutomatic=net$colors
# Convert labels to colors for plotting
moduleColorsAutomatic = labels2colors(moduleLabelsAutomatic)
# A data frame with module eigengenes can be obtained as follows
MEsAutomatic=net$MEs

####
replicate = as.data.frame(datTraits$replicate)
names(replicate)="replicate"
time = as.data.frame(datTraits$time)
names(time)="time"
temperature = as.data.frame(datTraits$temperature)
names(temperature)="temperature"
light_intensity = as.data.frame(datTraits$light_intensity)
names(light_intensity)="light_intensity"
FvFm = as.data.frame(datTraits$FvFm)
names(FvFm)="FvFm"
viol_micromol_per_mgDW = as.data.frame(datTraits$viol_micromol_per_mgDW)
names(viol_micromol_per_mgDW)="viol_micromol_per_mgDW"
X9_cis_neo_micromol_per_mgDW = as.data.frame(datTraits$X9_cis_neo_micromol_per_mgDW)
names(X9_cis_neo_micromol_per_mgDW)="X9_cis_neo_micromol_per_mgDW"
anthera_micromol_per_mgDW = as.data.frame(datTraits$anthera_micromol_per_mgDW)
names(anthera_micromol_per_mgDW)="anthera_micromol_per_mgDW"
Chlb_micromol_per_mgDW = as.data.frame(datTraits$Chlb_micromol_per_mgDW)
names(Chlb_micromol_per_mgDW)="Chlb_micromol_per_mgDW"
Lut_micromol_per_mgDW = as.data.frame(datTraits$Lut_micromol_per_mgDW)
names(Lut_micromol_per_mgDW)="Lut_micromol_per_mgDW"
Zeax_micromol_per_mgDW = as.data.frame(datTraits$Zeax_micromol_per_mgDW)
names(Zeax_micromol_per_mgDW)="Zeax_micromol_per_mgDW"
Chla_micromol_per_mgDW = as.data.frame(datTraits$Chla_micromol_per_mgDW)
names(Chla_micromol_per_mgDW)="Chla_micromol_per_mgDW"
alpha_car_micromol_per_mgDW = as.data.frame(datTraits$alpha_car_micromol_per_mgDW)
names(alpha_car_micromol_per_mgDW)="alpha_car_micromol_per_mgDW"
X11_cis_micromol_per_mgDW = as.data.frame(datTraits$X11_cis_micromol_per_mgDW)
names(X11_cis_micromol_per_mgDW)="X11_cis_micromol_per_mgDW"
beta_car_micromol_per_mgDW = as.data.frame(datTraits$beta_car_micromol_per_mgDW)
names(beta_car_micromol_per_mgDW)="beta_car_micromol_per_mgDW"
X9_cis_micromol_per_mgDW = as.data.frame(datTraits$X9_cis_micromol_per_mgDW)
names(X9_cis_micromol_per_mgDW)="X9_cis_micromol_per_mgDW"
X6MHO_nmol_per_mgDW = as.data.frame(datTraits$X6MHO_nmol_per_mgDW)
names(X6MHO_nmol_per_mgDW)="X6MHO_nmol_per_mgDW"
beta_CC_nmol_per_mgDW = as.data.frame(datTraits$beta_CC_nmol_per_mgDW)
names(beta_CC_nmol_per_mgDW)="beta_CC_nmol_per_mgDW"
beta_Io_nmol_per_mgDW = as.data.frame(datTraits$beta_Io_nmol_per_mgDW)
names(beta_Io_nmol_per_mgDW)="beta_Io_nmol_per_mgDW"
DHA_nmol_per_mgDW = as.data.frame(datTraits$DHA_nmol_per_mgDW)
names(DHA_nmol_per_mgDW)="DHA_nmol_per_mgDW"
DHA_per_beta_Io = as.data.frame(datTraits$DHA_per_beta_Io)
names(DHA_per_beta_Io)="DHA_per_beta_Io"
Chla_per_b = as.data.frame(datTraits$Chla_per_b)
names(Chla_per_b)="Chla_per_b"
beta_car_per_9_cis_neox = as.data.frame(datTraits$beta_car_per_9_cis_neox)
names(beta_car_per_9_cis_neox)="beta_car_per_9_cis_neox"
V_A_Z_per_Chla_b = as.data.frame(datTraits$V_A_Z_per_Chla_b)
names(V_A_Z_per_Chla_b)="V_A_Z_per_Chla_b"
A_Z_per_V_A_Z = as.data.frame(datTraits$A_Z_per_V_A_Z)
names(A_Z_per_V_A_Z)="A_Z_per_V_A_Z"
beta_Car_per_beta_CC = as.data.frame(datTraits$beta_Car_per_beta_CC)
names(beta_Car_per_beta_CC)="beta_Car_per_beta_CC"
beta_Car_per_beta_Io = as.data.frame(datTraits$beta_Car_per_beta_Io)
names(beta_Car_per_beta_Io)="beta_Car_per_beta_Io"
beta_Car_per_DHA = as.data.frame(datTraits$beta_Car_per_DHA)
names(beta_Car_per_DHA)="beta_Car_per_DHA"
beta_Car_per_beta_CC_beta_Io_DHA = as.data.frame(datTraits$beta_Car_per_beta_CC_beta_Io_DHA)
names(beta_Car_per_beta_CC_beta_Io_DHA)="beta_Car_per_beta_CC_beta_Io_DHA"

# Next use this trait to define a gene significance variable
GS.time=as.numeric(cor(datExpr,time,use="p"))
# This translates the numeric values into colors
GS.timeColor=numbers2colors(GS.time,signed=T)
# Next use this trait to define a gene significance variable
GS.temperature=as.numeric(cor(datExpr,temperature,use="p"))
# This translates the numeric values into colors
GS.temperatureColor=numbers2colors(GS.temperature,signed=T)
# Next use this trait to define a gene significance variable
GS.light_intensity=as.numeric(cor(datExpr,light_intensity,use="p"))
# This translates the numeric values into colors
GS.light_intensityColor=numbers2colors(GS.light_intensity,signed=T)
# Next use this trait to define a gene significance variable
GS.replicate=as.numeric(cor(datExpr,replicate,use="p"))
# This translates the numeric values into colors
GS.replicateColor=numbers2colors(GS.replicate,signed=T)
GS.FvFm=as.numeric(cor(datExpr, FvFm,use="p"))
GS.FvFmColor=numbers2colors(GS.FvFm, signed=T)
GS.viol_micromol_per_mgDW=as.numeric(cor(datExpr, viol_micromol_per_mgDW,use="p"))
GS.viol_micromol_per_mgDWColor=numbers2colors(GS.viol_micromol_per_mgDW, signed=T)
GS.X9_cis_neo_micromol_per_mgDW=as.numeric(cor(datExpr, X9_cis_neo_micromol_per_mgDW,use="p"))
GS.X9_cis_neo_micromol_per_mgDWColor=numbers2colors(GS.X9_cis_neo_micromol_per_mgDW, signed=T)
GS.anthera_micromol_per_mgDW=as.numeric(cor(datExpr, anthera_micromol_per_mgDW,use="p"))
GS.anthera_micromol_per_mgDWColor=numbers2colors(GS.anthera_micromol_per_mgDW, signed=T)
GS.Chlb_micromol_per_mgDW=as.numeric(cor(datExpr, Chlb_micromol_per_mgDW,use="p"))
GS.Chlb_micromol_per_mgDWColor=numbers2colors(GS.Chlb_micromol_per_mgDW, signed=T)
GS.Lut_micromol_per_mgDW=as.numeric(cor(datExpr, Lut_micromol_per_mgDW,use="p"))
GS.Lut_micromol_per_mgDWColor=numbers2colors(GS.Lut_micromol_per_mgDW, signed=T)
GS.Zeax_micromol_per_mgDW=as.numeric(cor(datExpr, Zeax_micromol_per_mgDW,use="p"))
GS.Zeax_micromol_per_mgDWColor=numbers2colors(GS.Zeax_micromol_per_mgDW, signed=T)
GS.Chla_micromol_per_mgDW=as.numeric(cor(datExpr, Chla_micromol_per_mgDW,use="p"))
GS.Chla_micromol_per_mgDWColor=numbers2colors(GS.Chla_micromol_per_mgDW, signed=T)
GS.alpha_car_micromol_per_mgDW=as.numeric(cor(datExpr, alpha_car_micromol_per_mgDW,use="p"))
GS.alpha_car_micromol_per_mgDWColor=numbers2colors(GS.alpha_car_micromol_per_mgDW, signed=T)
GS.X11_cis_micromol_per_mgDW=as.numeric(cor(datExpr, X11_cis_micromol_per_mgDW,use="p"))
GS.X11_cis_micromol_per_mgDWColor=numbers2colors(GS.X11_cis_micromol_per_mgDW, signed=T)
GS.beta_car_micromol_per_mgDW=as.numeric(cor(datExpr, beta_car_micromol_per_mgDW,use="p"))
GS.beta_car_micromol_per_mgDWColor=numbers2colors(GS.beta_car_micromol_per_mgDW, signed=T)
GS.X9_cis_micromol_per_mgDW=as.numeric(cor(datExpr, X9_cis_micromol_per_mgDW,use="p"))
GS.X9_cis_micromol_per_mgDWColor=numbers2colors(GS.X9_cis_micromol_per_mgDW, signed=T)
GS.X6MHO_nmol_per_mgDW=as.numeric(cor(datExpr, X6MHO_nmol_per_mgDW,use="p"))
GS.X6MHO_nmol_per_mgDWColor=numbers2colors(GS.X6MHO_nmol_per_mgDW, signed=T)
GS.beta_CC_nmol_per_mgDW=as.numeric(cor(datExpr, beta_CC_nmol_per_mgDW,use="p"))
GS.beta_CC_nmol_per_mgDWColor=numbers2colors(GS.beta_CC_nmol_per_mgDW, signed=T)
GS.beta_Io_nmol_per_mgDW=as.numeric(cor(datExpr, beta_Io_nmol_per_mgDW,use="p"))
GS.beta_Io_nmol_per_mgDWColor=numbers2colors(GS.beta_Io_nmol_per_mgDW, signed=T)
GS.DHA_nmol_per_mgDW=as.numeric(cor(datExpr, DHA_nmol_per_mgDW,use="p"))
GS.DHA_nmol_per_mgDWColor=numbers2colors(GS.DHA_nmol_per_mgDW, signed=T)
GS.DHA_per_beta_Io=as.numeric(cor(datExpr, DHA_per_beta_Io,use="p"))
GS.DHA_per_beta_IoColor=numbers2colors(GS.DHA_per_beta_Io, signed=T)
GS.Chla_per_b=as.numeric(cor(datExpr, Chla_per_b,use="p"))
GS.Chla_per_bColor=numbers2colors(GS.Chla_per_b, signed=T)
GS.beta_car_per_9_cis_neox=as.numeric(cor(datExpr, beta_car_per_9_cis_neox,use="p"))
GS.beta_car_per_9_cis_neoxColor=numbers2colors(GS.beta_car_per_9_cis_neox, signed=T)
GS.V_A_Z_per_Chla_b=as.numeric(cor(datExpr, V_A_Z_per_Chla_b,use="p"))
GS.V_A_Z_per_Chla_bColor=numbers2colors(GS.V_A_Z_per_Chla_b, signed=T)
GS.A_Z_per_V_A_Z=as.numeric(cor(datExpr, A_Z_per_V_A_Z,use="p"))
GS.A_Z_per_V_A_ZColor=numbers2colors(GS.A_Z_per_V_A_Z, signed=T)
GS.beta_Car_per_beta_CC=as.numeric(cor(datExpr, beta_Car_per_beta_CC,use="p"))
GS.beta_Car_per_beta_CCColor=numbers2colors(GS.beta_Car_per_beta_CC, signed=T)
GS.beta_Car_per_beta_Io=as.numeric(cor(datExpr, beta_Car_per_beta_Io,use="p"))
GS.beta_Car_per_beta_IoColor=numbers2colors(GS.beta_Car_per_beta_Io, signed=T)
GS.beta_Car_per_DHA=as.numeric(cor(datExpr, beta_Car_per_DHA,use="p"))
GS.beta_Car_per_DHAColor=numbers2colors(GS.beta_Car_per_DHA, signed=T)
GS.beta_Car_per_beta_CC_beta_Io_DHA=as.numeric(cor(datExpr, beta_Car_per_beta_CC_beta_Io_DHA,use="p"))
GS.beta_Car_per_beta_CC_beta_Io_DHAColor=numbers2colors(GS.beta_Car_per_beta_CC_beta_Io_DHA, signed=T)

###
blocknumber=1
datColors=data.frame(moduleColorsAutomatic,
                     GS.timeColor,
                     GS.light_intensityColor,
                     GS.temperatureColor,
                     GS.replicateColor,
                     GS.FvFmColor,
                     GS.viol_micromol_per_mgDWColor,
                     GS.X9_cis_neo_micromol_per_mgDWColor,
                     GS.anthera_micromol_per_mgDWColor,
                     GS.Chlb_micromol_per_mgDWColor,
                     GS.Lut_micromol_per_mgDWColor,
                     GS.Zeax_micromol_per_mgDWColor,
                     GS.Chla_micromol_per_mgDWColor,
                     GS.alpha_car_micromol_per_mgDWColor,
                     GS.X11_cis_micromol_per_mgDWColor,
                     GS.beta_car_micromol_per_mgDWColor,
                     GS.X9_cis_micromol_per_mgDWColor,
                     GS.X6MHO_nmol_per_mgDWColor,
                     GS.beta_CC_nmol_per_mgDWColor,
                     GS.beta_Io_nmol_per_mgDWColor,
                     GS.DHA_nmol_per_mgDWColor,
                     GS.DHA_per_beta_IoColor,
                     GS.Chla_per_bColor,
                     GS.beta_car_per_9_cis_neoxColor,
                     GS.V_A_Z_per_Chla_bColor,
                     GS.A_Z_per_V_A_ZColor,
                     GS.beta_Car_per_beta_CCColor,
                     GS.beta_Car_per_beta_IoColor,
                     GS.beta_Car_per_DHAColor,
                     GS.beta_Car_per_beta_CC_beta_Io_DHAColor)[net$blockGenes[[blocknumber]],]


# Plot the dendrogram and the module colors underneath
plotDendroAndColors(net$dendrograms[[blocknumber]],
                    colors=datColors,
                    groupLabels=c("Module colors",
                                  "GS.time",
                                  "GS.light_intensity",
                                  "GS.temperature",
                                  "GS.replicate",
                                  "GS.FvFm",
                                  "GS.viol_micromol_per_mgDW",
                                  "GS.X9_cis_neo_micromol_per_mgDW",
                                  "GS.anthera_micromol_per_mgDW",
                                  "GS.Chlb_micromol_per_mgDW",
                                  "GS.Lut_micromol_per_mgDW",
                                  "GS.Zeax_micromol_per_mgDW",
                                  "GS.Chla_micromol_per_mgDW",
                                  "GS.alpha_car_micromol_per_mgDW",
                                  "GS.X11_cis_micromol_per_mgDW",
                                  "GS.beta_car_micromol_per_mgDW",
                                  "GS.X9_cis_micromol_per_mgDW",
                                  "GS.X6MHO_nmol_per_mgDW",
                                  "GS.beta_CC_nmol_per_mgDW",
                                  "GS.beta_Io_nmol_per_mgDW",
                                  "GS.DHA_nmol_per_mgDW",
                                  "GS.DHA_per_beta_Io",
                                  "GS.Chla_per_b",
                                  "GS.beta_car_per_9_cis_neox",
                                  "GS.V_A_Z_per_Chla_b",
                                  "GS.A_Z_per_V_A_Z",
                                  "GS.beta_Car_per_beta_CC",
                                  "GS.beta_Car_per_beta_Io",
                                  "GS.beta_Car_per_DHA",
                                  "GS.beta_Car_per_beta_CC_beta_Io_DHA"),
                    dendroLabels=FALSE,
                    cex.colorLabels	= 0.5)


# Step 1: Call the pdf command to start the plot
pdf(file = "Analyses/WGCNA/plots/dendrogram_and_module_colors.pdf",   # The directory you want to save the file in
    width = 20, # The width of the plot in inches
    height = 20) # The height of the plot in inches
# Step 2: Create the plot with R code

# Plot the dendrogram and the module colors underneath
plotDendroAndColors(net$dendrograms[[blocknumber]],
                    colors=datColors,
                    groupLabels=c("Module colors",
                                  "GS.time",
                                  "GS.light_intensity",
                                  "GS.temperature",
                                  "GS.replicate",
                                  "GS.FvFm",
                                  "GS.viol_micromol_per_mgDW",
                                  "GS.X9_cis_neo_micromol_per_mgDW",
                                  "GS.anthera_micromol_per_mgDW",
                                  "GS.Chlb_micromol_per_mgDW",
                                  "GS.Lut_micromol_per_mgDW",
                                  "GS.Zeax_micromol_per_mgDW",
                                  "GS.Chla_micromol_per_mgDW",
                                  "GS.alpha_car_micromol_per_mgDW",
                                  "GS.X11_cis_micromol_per_mgDW",
                                  "GS.beta_car_micromol_per_mgDW",
                                  "GS.X9_cis_micromol_per_mgDW",
                                  "GS.X6MHO_nmol_per_mgDW",
                                  "GS.beta_CC_nmol_per_mgDW",
                                  "GS.beta_Io_nmol_per_mgDW",
                                  "GS.DHA_nmol_per_mgDW",
                                  "GS.DHA_per_beta_Io",
                                  "GS.Chla_per_b",
                                  "GS.beta_car_per_9_cis_neox",
                                  "GS.V_A_Z_per_Chla_b",
                                  "GS.A_Z_per_V_A_Z",
                                  "GS.beta_Car_per_beta_CC",
                                  "GS.beta_Car_per_beta_Io",
                                  "GS.beta_Car_per_DHA",
                                  "GS.beta_Car_per_beta_CC_beta_Io_DHA"),
                    dendroLabels=FALSE,
                    cex.colorLabels	= 0.5)

# Step 3: Run dev.off() to create the file!
dev.off()


# Calculate eigengenes
MEList=moduleEigengenes(datExpr,colors=moduleColorsAutomatic)
MEs = MEList$eigengenes
# Add the weight to existing module eigengenes
MET=orderMEs(cbind(MEs,time, light_intensity, temperature, replicate, FvFm, viol_micromol_per_mgDW, X9_cis_neo_micromol_per_mgDW, anthera_micromol_per_mgDW, Chlb_micromol_per_mgDW, Lut_micromol_per_mgDW, Zeax_micromol_per_mgDW, Chla_micromol_per_mgDW, alpha_car_micromol_per_mgDW, X11_cis_micromol_per_mgDW, beta_car_micromol_per_mgDW, X9_cis_micromol_per_mgDW, X6MHO_nmol_per_mgDW, beta_CC_nmol_per_mgDW, beta_Io_nmol_per_mgDW, DHA_nmol_per_mgDW, DHA_per_beta_Io, Chla_per_b, beta_car_per_9_cis_neox, V_A_Z_per_Chla_b, A_Z_per_V_A_Z, beta_Car_per_beta_CC, beta_Car_per_beta_Io, beta_Car_per_DHA, beta_Car_per_beta_CC_beta_Io_DHA))
# Plot the relationships among the eigengenes and the trait
plotEigengeneNetworks(MET,"",marDendro=c(0,4,1,2),
                      marHeatmap=c(3,8,3,8),cex.lab=0.8,xLabelsAngle=90)

# Step 1: Call the pdf command to start the plot
pdf(file = "Analyses/WGCNA/plots/relationship_between_eigengenes_and_the_trait.pdf",   # The directory you want to save the file in
    width = 25, # The width of the plot in inches
    height = 25) # The height of the plot in inches
# Step 2: Create the plot with R code

# Plot the relationships among the eigengenes and the trait
plotEigengeneNetworks(MET,"",marDendro=c(0,4,1,2),
                      marHeatmap=c(8,13,8,13),cex.lab=0.8,xLabelsAngle=90)

# Step 3: Run dev.off() to create the file!
dev.off()
################################################################################
##### Relating modules to physiological traits
################################################################################
# Choose a module assignment
moduleColors=moduleColorsAutomatic
# Define numbers of genes and samples
nGenes = ncol(datExpr)
nSamples = nrow(datExpr)
# Recalculate MEs with color labels
MEs0 = moduleEigengenes(datExpr,
                        moduleColors,
                        softPower = softPower)$eigengenes
MEs = orderMEs(MEs0)
modTraitCor = cor(MEs, datTraits, use = "p")
modTraitP = corPvalueStudent(modTraitCor, nSamples)
modTraitP.adj = p.adjust(modTraitP, method = "BH", n = length(modTraitP))

#Since we have a moderately large number of modules and traits,
#a suitable graphical representation will help in reading
#the table. We color code each association by the correlation value:
# Will display correlations and their p-values
textMatrix = paste(signif(modTraitCor, 2), "\n(",
                   signif(modTraitP.adj, 1), ")", sep = "")
dim(textMatrix) = dim(modTraitCor)
par(mar = c(6, 18, 3, 3))
# Display the correlation values within a heatmap plot
labeledHeatmap(Matrix = modTraitCor, xLabels = names(datTraits),
               yLabels = names(MEs), ySymbols = names(MEs),
               colorLabels =FALSE,colors=blueWhiteRed(50),textMatrix=textMatrix,
               setStdMargins = FALSE, cex.text = 0.5, zlim = c(-1,1),
               main = paste("Module-trait relationships"))

# Step 1: Call the pdf command to start the plot
pdf(file = "Analyses/WGCNA/plots/relating_module_and_traits_relationships.pdf",   # The directory you want to save the file in
    width = 20, # The width of the plot in inches
    height = 20) # The height of the plot in inches
# Step 2: Create the plot with R code

# Display the correlation values within a heatmap plot
labeledHeatmap(Matrix = modTraitCor, xLabels = names(datTraits),
               yLabels = names(MEs), ySymbols = names(MEs), cex.lab.y = 0.8,
               colorLabels =FALSE,colors=blueWhiteRed(50),textMatrix=textMatrix,
               setStdMargins = TRUE, cex.text = 1, zlim = c(-1,1),
               main = paste("Module-trait relationships"))

# Step 3: Run dev.off() to create the file!
dev.off()
################################################################################
##### Gene relationship to trait and important modules: Gene Significance and Module Membership
################################################################################
# calculate the module membership values
# (aka. module eigengene based connectivity kME):
datKME=signedKME(datExpr, MEs, corFnc = "bicor")

colorOfColumn=substring(names(datKME),4)
selectModules <- unique(moduleColors)

GSs <- c("replicate", "time", "temperature", "light_intensity", "FvFm", "viol_micromol_per_mgDW", "X9_cis_neo_micromol_per_mgDW", "anthera_micromol_per_mgDW", "Chlb_micromol_per_mgDW", "Lut_micromol_per_mgDW", "Zeax_micromol_per_mgDW", "Chla_micromol_per_mgDW", "alpha_car_micromol_per_mgDW", "X11_cis_micromol_per_mgDW", "beta_car_micromol_per_mgDW", "X9_cis_micromol_per_mgDW", "X6MHO_nmol_per_mgDW", "beta_CC_nmol_per_mgDW", "beta_Io_nmol_per_mgDW", "DHA_nmol_per_mgDW", "DHA_per_beta_Io", "Chla_per_b", "beta_car_per_9_cis_neox", "V_A_Z_per_Chla_b", "A_Z_per_V_A_Z", "beta_Car_per_beta_CC", "beta_Car_per_beta_Io", "beta_Car_per_DHA", "beta_Car_per_beta_CC_beta_Io_DHA")
for(geneSignificance in GSs){
    # calculate the module membership values
    # (aka. module eigengene based connectivity kME):
    datKME=signedKME(datExpr, MEs, corFnc = "bicor")
    
    colorOfColumn=substring(names(datKME),4)
    selectModules <- unique(moduleColors)
    
    for (module in selectModules) {
        column = match(module,colorOfColumn)
        restModule=moduleColors==module
        
        # Step 1: Call the pdf command to start the plot
        pdf(file = paste0("Analyses/WGCNA/plots/GS_Module_membership/", paste0("GS.", geneSignificance), "_", module,".pdf"),   # The directory you want to save the file in
            width = 20, # The width of the plot in inches
            height = 20) # The height of the plot in inches
        # Step 2: Create the plot with R code
        
        verboseScatterplot(datKME[restModule,column],get(paste0("GS.", geneSignificance))[restModule],
                           xlab=paste("Module Membership ",module,"module"),ylab=paste0("GS.", geneSignificance),
                           main=paste("kME.",module,"vs. GS"),
                           #col=module,
                           corFnc = "bicor")
        
        # Step 3: Run dev.off() to create the file!
        dev.off()
    }
    
    # Step 1: Call the pdf command to start the plot
    pdf(file = paste0("Analyses/WGCNA/plots/GS_Module_membership/", paste0("GS.", geneSignificance), "_all-in-one.pdf"),   # The directory you want to save the file in
        width = 21, # The width of the plot in inches
        height = 21) # The height of the plot in inches
    
    # Step 2: Create the plot with R code
    par(mfcol = c(5,6))
    for (module in selectModules) {
        par(mar = c(2.7,1.2,2.7,1.2))
        column = match(module,colorOfColumn)
        restModule=moduleColors==module
        verboseScatterplot(datKME[restModule,column],get(paste0("GS.", geneSignificance))[restModule],
                           xlab=paste("Module Membership ",module,"module"),
                           #ylab=paste0("GS.", geneSignificance),
                           main=paste(module),
                           corFnc = "bicor",
                           ylab=NA,
                           #col=module
                           )
    }
    par(mfcol = c(1,1))
    par(mar = rep(2,4))
    
    # Step 3: Run dev.off() to create the file!
    dev.off()
}
################################################################################
##### Output file for gene ontology analysis
################################################################################
# data frame with gene significances (cor with the traits)
datGS.Traits=data.frame(cor(datExpr,datTraits,use="p"))
names(datGS.Traits)=paste("cor",names(datGS.Traits),sep=".")

datIntraConnect <- intramodularConnectivity.fromExpr(datExpr,
                                                     colors=moduleColors,
                                                     corFnc= "bicor",
                                                     networkType= "signed",
                                                     power = softPower,
                                                     getWholeNetworkConnectivity=T)


datOutput=data.frame(GeneID=colnames(datExpr),
                     moduleColors,
                     datGS.Traits,
                     datKME,
                     datIntraConnect,
                     GS.replicateColor,
                     GS.timeColor,
                     GS.temperatureColor,
                     GS.light_intensityColor,
                     GS.FvFmColor,
                     GS.viol_micromol_per_mgDWColor,
                     GS.X9_cis_neo_micromol_per_mgDWColor,
                     GS.anthera_micromol_per_mgDWColor,
                     GS.Chlb_micromol_per_mgDWColor,
                     GS.Lut_micromol_per_mgDWColor,
                     GS.Zeax_micromol_per_mgDWColor,
                     GS.Chla_micromol_per_mgDWColor,
                     GS.alpha_car_micromol_per_mgDWColor,
                     GS.X11_cis_micromol_per_mgDWColor,
                     GS.beta_car_micromol_per_mgDWColor,
                     GS.X9_cis_micromol_per_mgDWColor,
                     GS.X6MHO_nmol_per_mgDWColor,
                     GS.beta_CC_nmol_per_mgDWColor,
                     GS.beta_Io_nmol_per_mgDWColor,
                     GS.DHA_nmol_per_mgDWColor,
                     GS.DHA_per_beta_IoColor,
                     GS.Chla_per_bColor,
                     GS.beta_car_per_9_cis_neoxColor,
                     GS.V_A_Z_per_Chla_bColor,
                     GS.A_Z_per_V_A_ZColor,
                     GS.beta_Car_per_beta_CCColor,
                     GS.beta_Car_per_beta_IoColor,
                     GS.beta_Car_per_DHAColor,
                     GS.beta_Car_per_beta_CC_beta_Io_DHAColor)
# save the results in a comma delimited file
write.table(datOutput,"Analyses/WGCNA/tables/WGCNA_Results.csv",row.names=F,sep=",")
################################################################################
##### Heatmap of the modules expression values
################################################################################
datExpr_zscale.df <- datExpr.df %>%
    select(-1) %>%
    t() %>%
    scale() %>%
    t() %>%
    as.data.frame()
datExpr_zscale.df <- cbind(datExpr.df$GeneID, datExpr_zscale.df)
colnames(datExpr_zscale.df) <- colnames(datExpr.df)

selectModules <- unique(moduleColors)

for (module in selectModules) {
    genes_in_this_module <- datOutput %>%
        filter(moduleColors == module) %>%
        select(GeneID) %>%
        unlist() %>%
        as_vector()
    
    expr_subset <- datExpr_zscale.df %>%
        filter(GeneID %in% genes_in_this_module) %>%
        pivot_longer(!c(GeneID), names_to = "Condition", values_to = "expression")
    
    p <- ggplot(expr_subset, aes((Condition), y = expression)) +
        geom_line(aes(group = GeneID), linewidth = 0.2, alpha = 0.3, color = "#c6cdce") +
        stat_smooth(data = subset(expr_subset, Condition %in% c("control_0_rep1", "control_0_rep2", "control_0_rep3", "control_0_rep4", "control_0_rep5", "control_0_rep6", "control_0.5_rep1", "control_0.5_rep2", "control_0.5_rep3", "control_1_rep1", "control_1_rep2", "control_1_rep3", "control_2_rep1", "control_2_rep2", "control_2_rep3", "control_4_rep1", "control_4_rep2", "control_4_rep3", "control_6_rep1", "control_6_rep2", "control_6_rep3", "control_24_rep1", "control_24_rep2", "control_24_rep3")),
                    aes(x = (Condition), y = expression, group = 1), method = "loess", se = FALSE, linetype = "solid", color = "#345053",  alpha = 1) +
        stat_smooth(data = subset(expr_subset, Condition %in% c("cold_0.5_rep1", "cold_0.5_rep2", "cold_0.5_rep3", "cold_1_rep1", "cold_1_rep2", "cold_1_rep3", "cold_2_rep1", "cold_2_rep2", "cold_2_rep3", "cold_4_rep1", "cold_4_rep2", "cold_4_rep3", "cold_6_rep1", "cold_6_rep2", "cold_6_rep3", "cold_24_rep1", "cold_24_rep2", "cold_24_rep3")),
                    aes(x = (Condition), y = expression, group = 1), method = "loess", se = FALSE, linetype = "solid", color = "#0077b6",  alpha = 1) +
        stat_smooth(data = subset(expr_subset, Condition %in% c("heat_0.5_rep1", "heat_0.5_rep2", "heat_0.5_rep3", "heat_1_rep1", "heat_1_rep2", "heat_1_rep3", "heat_2_rep1", "heat_2_rep2", "heat_2_rep3", "heat_4_rep1", "heat_4_rep2", "heat_4_rep3", "heat_6_rep1", "heat_6_rep2", "heat_6_rep3", "heat_24_rep1", "heat_24_rep2", "heat_24_rep3")),
                    aes(x = (Condition), y = expression, group = 1), method = "loess", se = FALSE, linetype = "solid", color = "#fe5d5d",  alpha = 1) +
        stat_smooth(data = subset(expr_subset, Condition %in% c("hl_s_0.25_rep1", "hl_s_0.25_rep2", "hl_s_0.25_rep3", "hl_s_0.5_rep1", "hl_s_0.5_rep2", "hl_s_0.5_rep3", "hl_s_2_rep1", "hl_s_2_rep2", "hl_s_2_rep3", "hl_s_4_rep1", "hl_s_4_rep2", "hl_s_4_rep3", "hl_s_6_rep1", "hl_s_6_rep2", "hl_s_6_rep3")),
                    aes(x = (Condition), y = expression, group = 1), method = "loess", se = FALSE, linetype = "solid", color = "#ffa201",  alpha = 1) +
        stat_smooth(data = subset(expr_subset, Condition %in% c("hl_r_0.25_rep1", "hl_r_0.25_rep2", "hl_r_0.25_rep3", "hl_r_0.5_rep1", "hl_r_0.5_rep2", "hl_r_0.5_rep3", "hl_r_1_rep1", "hl_r_1_rep2", "hl_r_1_rep3", "hl_r_2_rep1", "hl_r_2_rep2", "hl_r_2_rep3", "hl_r_4_rep1", "hl_r_4_rep2", "hl_r_4_rep3")),
                    aes(x = (Condition), y = expression, group = 1), method = "loess", se = FALSE, linetype = "solid", color = "#70960e",  alpha = 1) +
        scale_y_continuous(limits = c(-2.1, 2.1)) +
        labs(y = "Z-score standardized log2 expression values (CPM)",
             x = "Conditions",
             title = paste0("M. endlicherianum - ", module, "")) +
        scale_x_discrete(limits = as.vector(colnames(datExpr_zscale.df)[-1])) +
        theme_bw() +
        theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust=1))
    
    ggsave(filename = paste0("Analyses/WGCNA/plots/expression_profiles/",
                             module, ".pdf"), width = 21, height = 29, units = "cm", dpi = 300)
}

################################################################################
##### Enrichment
################################################################################
library(clusterProfiler)
library(enrichplot)
library(tidyverse)
library(dplyr)

## pir and plant are interesting.

module_table <- read.csv("Analyses/WGCNA/tables/WGCNA_Results.csv")
term2gene <- read_tsv("term2gene_GO.tsv")
term2name <- read_tsv("term2name_GO.tsv") %>%
    drop_na()
common <- dplyr::intersect(term2gene$gene, module_table$GeneID)
my_universe <- term2gene[term2gene$gene %in% module_table$GeneID,]

selectModules <- unique(module_table$moduleColors)

for (whichmodule in selectModules) {
    module <- filter(module_table, moduleColors==whichmodule) 
    genes <- module$GeneID
    
    enrichment <- enricher(genes,
                           TERM2GENE = term2gene,
                           TERM2NAME = term2name,
                           pvalueCutoff = 0.05,
                           universe = my_universe$gene,
                           qvalueCutoff = 0.05)

    #save the enrichment result
    write.csv(file = paste0("Analyses/WGCNA/tables/GO/",whichmodule,".csv"), x = enrichment@result)
    
    if (any(enrichment@result$p.adjust <= 0.05)){
        
        p <- dotplot(enrichment,
                     x= "geneRatio", # Options: GeneRatio, BgRatio, pvalue, p.adjust, qvalue
                     color="p.adjust",
                     orderBy = "x", # Options: GeneRatio, BgRatio, pvalue, p.adjust, qvalue
                     showCategory=50,
                     font.size=8) + ggtitle("dotplot for ORA")
        ggsave(filename = paste0("Analyses/WGCNA/plots/GO/dotplot/", whichmodule,".pdf"),plot =  p,  dpi = 600,
               width = 40, height = 40, units = "cm")
        
        p <- cnetplot(enrichment,
                      node_label="all",
                      showCategory = 200,
                      #colorEdge = TRUE,
                      cex_label_gene = 0.5,
                      cex_label_category=0.5,
                      layout = "kk")
        
        ggsave(filename = paste0("Analyses/WGCNA/plots/GO/cnetplot/", whichmodule,".pdf"),plot =  p,  dpi = 600,
               width =  60, height = 40, units = "cm")
    }
}


 ################################################################################
##### Gene expression profile for each module
################################################################################
library(MetBrewer)
library(pheatmap)

myheatcolors <- c("#033270", "#1368aa", "#4091c9", "#9dcee2",
                  "#FFFFFF",
                  "#f29479", "#f26a4f", "#ef3c2d", "#cb1b16")

for (whichmodule in selectModules) {
    module <- filter(module_table, moduleColors==whichmodule) 
    genes <- module$GeneID
    
    module_expr.df <- datExpr.df %>%
        filter(GeneID %in% genes)
    
    module_expr <- as.matrix(module_expr.df[,-1])
    rownames(module_expr) <- module_expr.df$GeneID
    
    p <- pheatmap(module_expr,
                  clustering_distance_rows = "euclidean",
                  clustering_distance_cols = "euclidean",
                  clustering_method="complete",
                  show_rownames = TRUE,
                  col = myheatcolors,
                  main=paste("Expression profile of module ", whichmodule),
                  scale ="row",
                  border_color=FALSE,
                  fontsize=8)
    
    # Step 1: Call the pdf command to start the plot
    pdf(file = paste0("Analyses/WGCNA/plots/module_heatmap/", whichmodule, ".pdf"),   # The directory you want to save the file in
        width = 29.7, # The width of the plot in inches
        height = 21) # The height of the plot in inches
    
    # Step 2: Create the plot with R code
    print(p)
    
    # Step 3: Run dev.off() to create the file!
    dev.off()
}

################################################################################
##### Find hubs
################################################################################
library(fuzzyjoin)

network <- read.csv("Analyses/WGCNA/tables/WGCNA_Results.csv")
datKME=signedKME(datExpr, MEs, corFnc = "bicor")
orthofinder <- read_tsv("../orthofinder/Phylogenetic_Hierarchical_Orthogroups/N0.tsv") %>%
    mutate(gene_ID_mapping = strsplit(as.character(M_endlicherianum), ", ")) %>%
    unnest(gene_ID_mapping)

for (whichmodule in selectModules) {
    network_sub <- network[network$moduleColors == whichmodule,]
    network_sub_Within_sorted <- network_sub[order(network_sub$kWithin,
                                                   decreasing = T),1]
    network_sub_Within_sorted_top20 <- network_sub_Within_sorted[1:20]
    write.csv(network_sub_Within_sorted_top20,
              file = paste0("Analyses/WGCNA/tables/hubs/within_module/", whichmodule, ".csv"))
    
    network_sub_Within_sorted_annotated <- network_sub[order(network_sub$kWithin,
                                                             decreasing = T), ] %>%
        select("GeneID") %>%
        left_join(orthofinder, by = c("GeneID"="gene_ID_mapping"))
    
    write_tsv(x = network_sub_Within_sorted_annotated,
              file = paste0("Analyses/WGCNA/tables/hubs/annotated_all_genes_sorted_by_connectivity_within/",
                            whichmodule, ".tsv") )
}
network_sorted <- network[order(network$kOut, decreasing = T),]
network_sorted_top300 <- network_sorted[1:300, c("GeneID", "moduleColors")]
write.csv(network_sorted_top300, file = "Analyses/WGCNA/tables/hubs/extra_modular.csv")

################################################################################
##### Biological theme comparison
################################################################################
## Biological theme comparison
lightyellow <- network %>%
    filter(moduleColors == "lightyellow")
blue <- network %>%
    filter(moduleColors == "blue")
green <- network %>%
    filter(moduleColors == "green")
turquoise <- network %>%
    filter(moduleColors == "turquoise")
salmon <- network %>%
    filter(moduleColors == "salmon")
brown <- network %>%
    filter(moduleColors == "brown")
magenta <- network %>%
    filter(moduleColors == "magenta")
red <- network %>%
    filter(moduleColors == "red")
yellow <- network %>%
    filter(moduleColors == "yellow")
tan <- network %>%
    filter(moduleColors == "tan")
black <- network %>%
    filter(moduleColors == "black")
grey60 <- network %>%
    filter(moduleColors == "grey60")
pink <- network %>%
    filter(moduleColors == "pink")
midnightblue <- network %>%
    filter(moduleColors == "midnightblue")
cyan <- network %>%
    filter(moduleColors == "cyan")
purple <- network %>%
    filter(moduleColors == "purple")
royalblue <- network %>%
    filter(moduleColors == "royalblue")
darkred <- network %>%
    filter(moduleColors == "darkred")
greenyellow <- network %>%
    filter(moduleColors == "greenyellow")
lightgreen <- network %>%
    filter(moduleColors == "lightgreen")
lightcyan <- network %>%
    filter(moduleColors == "lightcyan")
darkturquoise <- network %>%
    filter(moduleColors == "darkturquoise")
orange <- network %>%
    filter(moduleColors == "orange")
darkorange <- network %>%
    filter(moduleColors == "darkorange")
darkgreen <- network %>%
    filter(moduleColors == "darkgreen")
grey <- network %>%
    filter(moduleColors == "grey")
darkgrey <- network %>%
    filter(moduleColors == "darkgrey")

term2gene <- read_tsv("term2gene_GO.tsv")
term2name <- read_tsv("term2name_GO.tsv") %>%
    drop_na()
common <- dplyr::intersect(term2gene$gene, datExpr.df$GeneID)

my_universe <- term2gene[term2gene$gene %in% datExpr.df$GeneID,]

gene_list <- list(lightyellow=as.vector(lightyellow$GeneID,),
                  blue=as.vector(blue$GeneID,),
                  green=as.vector(green$GeneID,),
                  turquoise=as.vector(turquoise$GeneID,),
                  salmon=as.vector(salmon$GeneID,),
                  brown=as.vector(brown$GeneID,),
                  magenta=as.vector(magenta$GeneID,),
                  red=as.vector(red$GeneID,),
                  yellow=as.vector(yellow$GeneID,),
                  tan=as.vector(tan$GeneID,),
                  black=as.vector(black$GeneID,),
                  grey60=as.vector(grey60$GeneID,),
                  pink=as.vector(pink$GeneID,),
                  midnightblue=as.vector(midnightblue$GeneID,),
                  cyan=as.vector(cyan$GeneID,),
                  purple=as.vector(purple$GeneID,),
                  royalblue=as.vector(royalblue$GeneID,),
                  darkred=as.vector(darkred$GeneID,),
                  greenyellow=as.vector(greenyellow$GeneID,),
                  lightgreen=as.vector(lightgreen$GeneID,),
                  lightcyan=as.vector(lightcyan$GeneID,),
                  darkturquoise=as.vector(darkturquoise$GeneID,),
                  orange=as.vector(orange$GeneID,),
                  darkorange=as.vector(darkorange$GeneID,),
                  darkgreen=as.vector(darkgreen$GeneID,),
                  grey=as.vector(grey$GeneID,),
                  darkgrey=as.vector(darkgrey$GeneID,)
)

xx <- compareCluster(geneClusters=gene_list,
                     fun="enricher", pvalueCutoff=0.05, TERM2GENE=term2gene, TERM2NAME=term2name,
                     pAdjustMethod = "BH",
                     minGSSize = 10, # default 10
                     maxGSSize = 1000, # default 500
                     qvalueCutoff = 0.2,
                     universe = my_universe$gene)
xx <- enrichplot::pairwise_termsim(xx, showCategory=1000)

write_tsv(x = xx@compareClusterResult, file = "Analyses/WGCNA/tables/biological_theme_comparison.tsv")

# Step 1: Call the pdf command to start the plot
pdf(file = paste0("Analyses/WGCNA/plots/biological_theme_comparison/10.pdf"),   # The directory you want to save the file in
    width = 21, # The width of the plot in inches
    height = 21) # The height of the plot in inches

# Step 2: Create the plot with R code
emapplot(xx, showCategory = 10, pie="equal", color = "p.adjust", shadowtext=F,
         label_style="ggforce",
         cex_category=1, layout="fr")  +
    scale_fill_manual(values = c("lightyellow" = "lightyellow",
                                 "blue" = "blue",
                                 "green" = "green",
                                 "turquoise" = "turquoise",
                                 "salmon" = "salmon",
                                 "brown" = "brown",
                                 "magenta" = "magenta",
                                 "red" = "red",
                                 "yellow" = "yellow",
                                 "tan" = "tan",
                                 "black" = "black",
                                 "grey60" = "grey60",
                                 "pink" = "pink",
                                 "midnightblue" = "midnightblue",
                                 "cyan" = "cyan",
                                 "purple" = "purple",
                                 "royalblue" = "royalblue",
                                 "darkred" = "darkred",
                                 "greenyellow" = "greenyellow",
                                 "lightgreen" = "lightgreen",
                                 "lightcyan" = "lightcyan",
                                 "darkturquoise" = "darkturquoise",
                                 "orange" = "orange",
                                 "darkorange" = "darkorange",
                                 "darkgreen" = "darkgreen",
                                 "grey" = "grey",
                                 "darkgrey" = "darkgrey"))

# Step 3: Run dev.off() to create the file!
dev.off()
################################################################################
##### Gene significance
################################################################################
library(ggplot2)
library(ggforce)
library(ggdist)
library(gghalves)
library(tidyverse)

data <- read.csv("Analyses/WGCNA/tables/WGCNA_Results.csv")
head(data)

info <- data %>%
    group_by(moduleColors) %>%
    summarise(n = n())

data <- data %>%
    mutate(colorCode = case_when(
        moduleColors == "lightyellow" ~ "lightyellow",
        moduleColors == "blue" ~ "blue",
        moduleColors == "green" ~ "green",
        moduleColors == "turquoise" ~ "turquoise",
        moduleColors == "salmon" ~ "salmon",
        moduleColors == "brown" ~ "brown",
        moduleColors == "magenta" ~ "magenta",
        moduleColors == "red" ~ "red",
        moduleColors == "yellow" ~ "yellow",
        moduleColors == "tan" ~ "tan",
        moduleColors == "black" ~ "black",
        moduleColors == "grey60" ~ "grey60",
        moduleColors == "pink" ~ "pink",
        moduleColors == "midnightblue" ~ "midnightblue",
        moduleColors == "cyan" ~ "cyan",
        moduleColors == "purple" ~ "purple",
        moduleColors == "royalblue" ~ "royalblue",
        moduleColors == "darkred" ~ "darkred",
        moduleColors == "greenyellow" ~ "greenyellow",
        moduleColors == "lightgreen" ~ "lightgreen",
        moduleColors == "lightcyan" ~ "lightcyan",
        moduleColors == "darkturquoise" ~ "darkturquoise",
        moduleColors == "orange" ~ "orange",
        moduleColors == "darkorange" ~ "darkorange",
        moduleColors == "darkgreen" ~ "darkgreen",
        moduleColors == "grey" ~ "grey",
        moduleColors == "darkgrey" ~ "darkgrey"
    ))

myColors <- c("lightyellow", "blue", "green", "turquoise", "salmon", "brown", "magenta", "red", "yellow", "tan", "black", "grey60", "pink", "midnightblue", "cyan", "purple", "royalblue", "darkred", "greenyellow", "lightgreen", "lightcyan", "darkturquoise", "orange", "darkorange", "darkgreen", "grey", "darkgrey")
myColors <- sort(myColors)


GSs <- c("replicate", "time", "temperature", "light_intensity", "FvFm", "viol_micromol_per_mgDW", "X9_cis_neo_micromol_per_mgDW", "anthera_micromol_per_mgDW", "Chlb_micromol_per_mgDW", "Lut_micromol_per_mgDW", "Zeax_micromol_per_mgDW", "Chla_micromol_per_mgDW", "alpha_car_micromol_per_mgDW", "X11_cis_micromol_per_mgDW", "beta_car_micromol_per_mgDW", "X9_cis_micromol_per_mgDW", "X6MHO_nmol_per_mgDW", "beta_CC_nmol_per_mgDW", "beta_Io_nmol_per_mgDW", "DHA_nmol_per_mgDW", "DHA_per_beta_Io", "Chla_per_b", "beta_car_per_9_cis_neox", "V_A_Z_per_Chla_b", "A_Z_per_V_A_Z", "beta_Car_per_beta_CC", "beta_Car_per_beta_Io", "beta_Car_per_DHA", "beta_Car_per_beta_CC_beta_Io_DHA")
for(geneSignificance in GSs){
    # absolute
    ggplot(data, aes(moduleColors, abs(get(paste0("GS.", geneSignificance))))) +
        ggdist::stat_halfeye(adjust = .5, width = .5, .width = 0, justification = -.4) +
        gghalves::geom_half_point(side = "l", range_scale = .5, alpha = .3, color="black", fill= myColors, shape=21, size=1 ) +
        geom_boxplot(width = .3, outlier.shape = NA, fill= myColors, alpha = 0.3) +
        ggtitle(paste0("Absolute value of gene significance for all genes in different modules with respect to: ", geneSignificance)) +
        labs(y = "Gene Significance", x = "Modules") +
        theme_bw() +
        scale_x_discrete(labels=c(paste0(info$moduleColors[1], "-", as.character(info$n[1])), paste0(info$moduleColors[2], "-", as.character(info$n[2])), paste0(info$moduleColors[3], "-", as.character(info$n[3])), paste0(info$moduleColors[4], "-", as.character(info$n[4])), paste0(info$moduleColors[5], "-", as.character(info$n[5])), paste0(info$moduleColors[6], "-", as.character(info$n[6])), paste0(info$moduleColors[7], "-", as.character(info$n[7])), paste0(info$moduleColors[8], "-", as.character(info$n[8])), paste0(info$moduleColors[9], "-", as.character(info$n[9])), paste0(info$moduleColors[10], "-", as.character(info$n[10])), paste0(info$moduleColors[11], "-", as.character(info$n[11])), paste0(info$moduleColors[12], "-", as.character(info$n[12])), paste0(info$moduleColors[13], "-", as.character(info$n[13])), paste0(info$moduleColors[14], "-", as.character(info$n[14])), paste0(info$moduleColors[15], "-", as.character(info$n[15])), paste0(info$moduleColors[16], "-", as.character(info$n[16])), paste0(info$moduleColors[17], "-", as.character(info$n[17])), paste0(info$moduleColors[18], "-", as.character(info$n[18])), paste0(info$moduleColors[19], "-", as.character(info$n[19])), paste0(info$moduleColors[20], "-", as.character(info$n[20])), paste0(info$moduleColors[21], "-", as.character(info$n[21])), paste0(info$moduleColors[22], "-", as.character(info$n[22])), paste0(info$moduleColors[23], "-", as.character(info$n[23])), paste0(info$moduleColors[24], "-", as.character(info$n[24])), paste0(info$moduleColors[25], "-", as.character(info$n[25])), paste0(info$moduleColors[26], "-", as.character(info$n[26])),
                                  paste0(info$moduleColors[27], "-", as.character(info$n[27]))))+
        theme(axis.text.x = element_text(angle = 90))
    ggsave(filename = paste0("Analyses/WGCNA/plots/Gene_Significance/absolute_value/", geneSignificance,".pdf"), plot = last_plot(),
           width = 40, height = 20, units = "cm", dpi = 600, bg = NULL, limitsize = FALSE)
    # normal 
    ggplot(data, aes(moduleColors, get(paste0("GS.", geneSignificance)))) +
        ggdist::stat_halfeye(adjust = .5, width = .5, .width = 0, justification = -.4) +
        gghalves::geom_half_point(side = "l", range_scale = .5, alpha = .3, color="black", fill= myColors, shape=21, size=1 ) +
        geom_boxplot(width = .3, outlier.shape = NA, fill= myColors, alpha = 0.3) +
        ggtitle(paste0("Gene significance for all genes in different modules with respect to: ", geneSignificance)) +
        labs(y = "Gene Significance", x = "Modules") +
        theme_bw() +
        scale_x_discrete(labels=c(paste0(info$moduleColors[1], "-", as.character(info$n[1])), paste0(info$moduleColors[2], "-", as.character(info$n[2])), paste0(info$moduleColors[3], "-", as.character(info$n[3])), paste0(info$moduleColors[4], "-", as.character(info$n[4])), paste0(info$moduleColors[5], "-", as.character(info$n[5])), paste0(info$moduleColors[6], "-", as.character(info$n[6])), paste0(info$moduleColors[7], "-", as.character(info$n[7])), paste0(info$moduleColors[8], "-", as.character(info$n[8])), paste0(info$moduleColors[9], "-", as.character(info$n[9])), paste0(info$moduleColors[10], "-", as.character(info$n[10])), paste0(info$moduleColors[11], "-", as.character(info$n[11])), paste0(info$moduleColors[12], "-", as.character(info$n[12])), paste0(info$moduleColors[13], "-", as.character(info$n[13])), paste0(info$moduleColors[14], "-", as.character(info$n[14])), paste0(info$moduleColors[15], "-", as.character(info$n[15])), paste0(info$moduleColors[16], "-", as.character(info$n[16])), paste0(info$moduleColors[17], "-", as.character(info$n[17])), paste0(info$moduleColors[18], "-", as.character(info$n[18])), paste0(info$moduleColors[19], "-", as.character(info$n[19])), paste0(info$moduleColors[20], "-", as.character(info$n[20])), paste0(info$moduleColors[21], "-", as.character(info$n[21])), paste0(info$moduleColors[22], "-", as.character(info$n[22])), paste0(info$moduleColors[23], "-", as.character(info$n[23])), paste0(info$moduleColors[24], "-", as.character(info$n[24])), paste0(info$moduleColors[25], "-", as.character(info$n[25])), paste0(info$moduleColors[26], "-", as.character(info$n[26])),
                                  paste0(info$moduleColors[27], "-", as.character(info$n[27]))))+
        theme(axis.text.x = element_text(angle = 90))
    ggsave(filename = paste0("Analyses/WGCNA/plots/Gene_Significance/value/", geneSignificance, ".pdf"), plot = last_plot(),
           width = 40, height = 20, units = "cm", dpi = 600, bg = NULL, limitsize = FALSE)
}
